maint.mk: drop redundant check
[gnulib.git] / top / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2011 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Override this in cfg.mk if you use a non-standard build-aux directory.
25 build_aux ?= $(srcdir)/build-aux
26
27 # Do not save the original name or timestamp in the .tar.gz file.
28 # Use --rsyncable if available.
29 gzip_rsyncable := \
30   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31     && printf %s --rsyncable)
32 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33
34 GIT = git
35 VC = $(GIT)
36
37 VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
38
39 # You can override this variable in cfg.mk to set your own regexp
40 # matching files to ignore.
41 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
42
43 # This is to preprocess robustly the output of $(VC_LIST), so that even
44 # when $(srcdir) is a pathological name like "....", the leading sed command
45 # removes only the intended prefix.
46 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
47
48 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
49 # when $(srcdir) is not ".".
50 ifeq ($(srcdir),.)
51 _prepend_srcdir_prefix =
52 else
53 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
54 endif
55
56 # In order to be able to consistently filter "."-relative names,
57 # (i.e., with no $(srcdir) prefix), this definition is careful to
58 # remove any $(srcdir) prefix, and to restore what it removes.
59 _sc_excl = \
60   $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
61 VC_LIST_EXCEPT = \
62   $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
63         | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
64           else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
65         | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
66         $(_prepend_srcdir_prefix)
67
68 ifeq ($(origin prev_version_file), undefined)
69   prev_version_file = $(srcdir)/.prev-version
70 endif
71
72 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
73 VERSION_REGEXP = $(subst .,\.,$(VERSION))
74 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
75
76 ifeq ($(VC),$(GIT))
77 this-vc-tag = v$(VERSION)
78 this-vc-tag-regexp = v$(VERSION_REGEXP)
79 else
80 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
81 tag-this-version = $(subst .,_,$(VERSION))
82 this-vc-tag = $(tag-package)-$(tag-this-version)
83 this-vc-tag-regexp = $(this-vc-tag)
84 endif
85 my_distdir = $(PACKAGE)-$(VERSION)
86
87 # Old releases are stored here.
88 release_archive_dir ?= ../release
89
90 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
91 # Use alpha.gnu.org for alpha and beta releases.
92 # Use ftp.gnu.org for stable releases.
93 gnu_ftp_host-alpha = alpha.gnu.org
94 gnu_ftp_host-beta = alpha.gnu.org
95 gnu_ftp_host-stable = ftp.gnu.org
96 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
97
98 ifeq ($(gnu_rel_host),ftp.gnu.org)
99 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
100 else
101 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
102 endif
103
104 # Override this in cfg.mk if you are using a different format in your
105 # NEWS file.
106 today = $(shell date +%Y-%m-%d)
107
108 # Select which lines of NEWS are searched for $(news-check-regexp).
109 # This is a sed line number spec.  The default says that we search
110 # lines 1..10 of NEWS for $(news-check-regexp).
111 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
112 news-check-lines-spec ?= 1,10
113 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
114
115 # Prevent programs like 'sort' from considering distinct strings to be equal.
116 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
117 export LC_ALL = C
118
119 ## --------------- ##
120 ## Sanity checks.  ##
121 ## --------------- ##
122
123 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
124
125 # Collect the names of rules starting with `sc_'.
126 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
127                         $(srcdir)/$(ME) $(_cfg_mk)))
128 .PHONY: $(syntax-check-rules)
129
130 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
131 local-checks-available += $(syntax-check-rules)
132 else
133 local-checks-available += no-vc-detected
134 no-vc-detected:
135         @echo "No version control files detected; skipping syntax check"
136 endif
137 .PHONY: $(local-checks-available)
138
139 # Arrange to print the name of each syntax-checking rule just before running it.
140 $(syntax-check-rules): %: %.m
141 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
142 .PHONY: $(sc_m_rules_)
143 $(sc_m_rules_):
144         @echo $(patsubst sc_%.m, %, $@)
145         @date +%s.%N > .sc-start-$(basename $@)
146
147 # Compute and print the elapsed time for each syntax-check rule.
148 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
149 .PHONY: $(sc_z_rules_)
150 $(sc_z_rules_): %.z: %
151         @end=$$(date +%s.%N);                                           \
152         start=$$(cat .sc-start-$*);                                     \
153         rm -f .sc-start-$*;                                             \
154         awk -v s=$$start -v e=$$end                                     \
155           'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
156
157 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
158 # that computes and prints elapsed time.
159 local-check :=                                                          \
160   $(patsubst sc_%, sc_%.z,                                              \
161     $(filter-out $(local-checks-to-skip), $(local-checks-available)))
162
163 syntax-check: $(local-check)
164
165 # _sc_search_regexp
166 #
167 # This macro searches for a given construct in the selected files and
168 # then takes some action.
169 #
170 # Parameters (shell variables):
171 #
172 #  prohibit | require
173 #
174 #     Regular expression (ERE) denoting either a forbidden construct
175 #     or a required construct.  Those arguments are exclusive.
176 #
177 #  in_vc_files | in_files
178 #
179 #     grep-E-style regexp denoting the files to check.  If no files
180 #     are specified the default are all the files that are under
181 #     version control.
182 #
183 #  containing | non_containing
184 #
185 #     Select the files (non) containing strings matching this regexp.
186 #     If both arguments are specified then CONTAINING takes
187 #     precedence.
188 #
189 #  with_grep_options
190 #
191 #     Extra options for grep.
192 #
193 #  ignore_case
194 #
195 #     Ignore case.
196 #
197 #  halt
198 #
199 #     Message to display before to halting execution.
200 #
201 # Finally, you may exempt files based on an ERE matching file names.
202 # For example, to exempt from the sc_space_tab check all files with the
203 # .diff suffix, set this Make variable:
204 #
205 # exclude_file_name_regexp--sc_space_tab = \.diff$
206 #
207 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
208 # when filtering by name via in_files, we explicitly filter out matching
209 # names here as well.
210
211 # By default, _sc_search_regexp does not ignore case.
212 export ignore_case =
213 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
214
215 define _sc_say_and_exit
216    dummy=; : so we do not need a semicolon before each use;             \
217    { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
218 endef
219
220 # _sc_search_regexp used to be named _prohibit_regexp.  However,
221 # upgrading to the new definition and leaving the old name undefined
222 # would usually convert each custom rule using $(_prohibit_regexp)
223 # (usually defined in cfg.mk) into a no-op.  This definition ensures
224 # that people know right away if they're still using the old name.
225 # FIXME: remove in 2012.
226 _prohibit_regexp = \
227   $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
228
229 define _sc_search_regexp
230    dummy=; : so we do not need a semicolon before each use;             \
231                                                                         \
232    : Check arguments;                                                   \
233    test -n "$$prohibit" && test -n "$$require"                          \
234      && { msg='Cannot specify both prohibit and require'                \
235           $(_sc_say_and_exit) } || :;                                   \
236    test -z "$$prohibit" && test -z "$$require"                          \
237      && { msg='Should specify either prohibit or require'               \
238           $(_sc_say_and_exit) } || :;                                   \
239    test -n "$$in_vc_files" && test -n "$$in_files"                      \
240      && { msg='Cannot specify both in_vc_files and in_files'            \
241           $(_sc_say_and_exit) } || :;                                   \
242    test "x$$halt" != x                                                  \
243      || { msg='halt not defined' $(_sc_say_and_exit) };                 \
244                                                                         \
245    : Filter by file name;                                               \
246    if test -n "$$in_files"; then                                        \
247      files=$$(find $(srcdir) | grep -E "$$in_files"                     \
248               | grep -Ev '$(exclude_file_name_regexp--$@)');            \
249    else                                                                 \
250      files=$$($(VC_LIST_EXCEPT));                                       \
251      if test -n "$$in_vc_files"; then                                   \
252        files=$$(echo "$$files" | grep -E "$$in_vc_files");              \
253      fi;                                                                \
254    fi;                                                                  \
255                                                                         \
256    : Filter by content;                                                 \
257    test -n "$$files" && test -n "$$containing"                          \
258      && { files=$$(grep -l "$$containing" $$files); } || :;             \
259    test -n "$$files" && test -n "$$non_containing"                      \
260      && { files=$$(grep -vl "$$non_containing" $$files); } || :;        \
261                                                                         \
262    : Check for the construct;                                           \
263    if test -n "$$files"; then                                           \
264      if test -n "$$prohibit"; then                                      \
265        grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
266          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
267      else                                                               \
268        grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
269            | grep .                                                     \
270          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
271      fi                                                                 \
272    else :;                                                              \
273    fi || :;
274 endef
275
276 sc_avoid_if_before_free:
277         @$(build_aux)/useless-if-before-free                            \
278                 $(useless_free_options)                                 \
279             $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) &&   \
280           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
281             exit 1; } || :
282
283 sc_cast_of_argument_to_free:
284         @prohibit='\<free *\( *\(' halt='don'\''t cast free argument'   \
285           $(_sc_search_regexp)
286
287 sc_cast_of_x_alloc_return_value:
288         @prohibit='\*\) *x(m|c|re)alloc\>'                              \
289         halt='don'\''t cast x*alloc return value'                       \
290           $(_sc_search_regexp)
291
292 sc_cast_of_alloca_return_value:
293         @prohibit='\*\) *alloca\>'                                      \
294         halt='don'\''t cast alloca return value'                        \
295           $(_sc_search_regexp)
296
297 sc_space_tab:
298         @prohibit='[ ]  '                                               \
299         halt='found SPACE-TAB sequence; remove the SPACE'               \
300           $(_sc_search_regexp)
301
302 # Don't use *scanf or the old ato* functions in `real' code.
303 # They provide no error checking mechanism.
304 # Instead, use strto* functions.
305 sc_prohibit_atoi_atof:
306         @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\('                           \
307         halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q'   \
308           $(_sc_search_regexp)
309
310 # Use STREQ rather than comparing strcmp == 0, or != 0.
311 sc_prohibit_strcmp:
312         @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]='   \
313             $$($(VC_LIST_EXCEPT))                                       \
314           | grep -vE ':# *define STRN?EQ\(' &&                          \
315           { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
316                 1>&2; exit 1; } || :
317
318 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
319 # Convert all uses automatically, via these two commands:
320 # git grep -l '\<exit *(1)' \
321 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
322 #  | xargs --no-run-if-empty \
323 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
324 # git grep -l '\<exit *(0)' \
325 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
326 #  | xargs --no-run-if-empty \
327 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
328 sc_prohibit_magic_number_exit:
329         @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,'     \
330         halt='use EXIT_* values rather than magic number'                       \
331           $(_sc_search_regexp)
332
333 # Using EXIT_SUCCESS as the first argument to error is misleading,
334 # since when that parameter is 0, error does not exit.  Use `0' instead.
335 sc_error_exit_success:
336         @prohibit='error *\(EXIT_SUCCESS,'                              \
337         in_vc_files='\.[chly]$$'                                        \
338         halt='found error (EXIT_SUCCESS'                                \
339          $(_sc_search_regexp)
340
341 # `FATAL:' should be fully upper-cased in error messages
342 # `WARNING:' should be fully upper-cased, or fully lower-cased
343 sc_error_message_warn_fatal:
344         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
345             | grep -E '"Warning|"Fatal|"fatal' &&                       \
346           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
347             exit 1; } || :
348
349 # Error messages should not start with a capital letter
350 sc_error_message_uppercase:
351         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
352             | grep -E '"[A-Z]'                                          \
353             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
354           { echo '$(ME): found capitalized error message' 1>&2;         \
355             exit 1; } || :
356
357 # Error messages should not end with a period
358 sc_error_message_period:
359         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
360             | grep -E '[^."]\."' &&                                     \
361           { echo '$(ME): found error message ending in period' 1>&2;    \
362             exit 1; } || :
363
364 sc_file_system:
365         @prohibit=file''system                                          \
366         ignore_case=1                                                   \
367         halt='found use of "file''system"; spell it "file system"'      \
368           $(_sc_search_regexp)
369
370 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
371 sc_prohibit_have_config_h:
372         @prohibit='^# *if.*HAVE''_CONFIG_H'                             \
373         halt='found use of HAVE''_CONFIG_H; remove'                     \
374           $(_sc_search_regexp)
375
376 # Nearly all .c files must include <config.h>.  However, we also permit this
377 # via inclusion of a package-specific header, if cfg.mk specified one.
378 # config_h_header must be suitable for grep -E.
379 config_h_header ?= <config\.h>
380 sc_require_config_h:
381         @require='^# *include $(config_h_header)'                       \
382         in_vc_files='\.c$$'                                             \
383         halt='the above files do not include <config.h>'                \
384           $(_sc_search_regexp)
385
386 # You must include <config.h> before including any other header file.
387 # This can possibly be via a package-specific header, if given by cfg.mk.
388 sc_require_config_h_first:
389         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then       \
390           fail=0;                                                       \
391           for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do             \
392             grep '^# *include\>' $$i | sed 1q                           \
393                 | grep -E '^# *include $(config_h_header)' > /dev/null  \
394               || { echo $$i; fail=1; };                                 \
395           done;                                                         \
396           test $$fail = 1 &&                                            \
397             { echo '$(ME): the above files include some other header'   \
398                 'before <config.h>' 1>&2; exit 1; } || :;               \
399         else :;                                                         \
400         fi
401
402 sc_prohibit_HAVE_MBRTOWC:
403         @prohibit='\bHAVE_MBRTOWC\b'                                    \
404         halt="do not use $$prohibit; it is always defined"              \
405           $(_sc_search_regexp)
406
407 # To use this "command" macro, you must first define two shell variables:
408 # h: the header, enclosed in <> or ""
409 # re: a regular expression that matches IFF something provided by $h is used.
410 define _sc_header_without_use
411   dummy=; : so we do not need a semicolon before each use;              \
412   h_esc=`echo "$$h"|sed 's/\./\\\\./g'`;                                \
413   if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then              \
414     files=$$(grep -l '^# *include '"$$h_esc"                            \
415              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
416     grep -LE "$$re" $$files | grep . &&                                 \
417       { echo "$(ME): the above files include $$h but don't use it"      \
418         1>&2; exit 1; } || :;                                           \
419   else :;                                                               \
420   fi
421 endef
422
423 # Prohibit the inclusion of assert.h without an actual use of assert.
424 sc_prohibit_assert_without_use:
425         @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
426
427 # Prohibit the inclusion of close-stream.h without an actual use.
428 sc_prohibit_close_stream_without_use:
429         @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
430
431 # Prohibit the inclusion of getopt.h without an actual use.
432 sc_prohibit_getopt_without_use:
433         @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
434
435 # Don't include quotearg.h unless you use one of its functions.
436 sc_prohibit_quotearg_without_use:
437         @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
438
439 # Don't include quote.h unless you use one of its functions.
440 sc_prohibit_quote_without_use:
441         @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
442
443 # Don't include this header unless you use one of its functions.
444 sc_prohibit_long_options_without_use:
445         @h='"long-options.h"' re='\<parse_long_options *\(' \
446           $(_sc_header_without_use)
447
448 # Don't include this header unless you use one of its functions.
449 sc_prohibit_inttostr_without_use:
450         @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
451           $(_sc_header_without_use)
452
453 # Don't include this header unless you use one of its functions.
454 sc_prohibit_ignore_value_without_use:
455         @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
456           $(_sc_header_without_use)
457
458 # Don't include this header unless you use one of its functions.
459 sc_prohibit_error_without_use:
460         @h='"error.h"' \
461         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
462           $(_sc_header_without_use)
463
464 # Don't include xalloc.h unless you use one of its functions.
465 # Consider these symbols:
466 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
467 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
468 # Divide into two sets on case, and filter each through this:
469 # | sort | perl -MRegexp::Assemble -le \
470 #  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
471 # Note this was produced by the above:
472 # _xa1 = \
473 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
474 # But we can do better, in at least two ways:
475 # 1) take advantage of two "dup"-suffixed strings:
476 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
477 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
478 # "char|[cmz]"
479 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
480 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
481 _xa2 = X([CZ]|N?M)ALLOC
482 sc_prohibit_xalloc_without_use:
483         @h='"xalloc.h"' \
484         re='\<($(_xa1)|$(_xa2)) *\('\
485           $(_sc_header_without_use)
486
487 # Extract function names:
488 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
489 _hash_re = \
490 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
491 _hash_fn = \<($(_hash_re)) *\(
492 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
493 sc_prohibit_hash_without_use:
494         @h='"hash.h"' \
495         re='$(_hash_fn)|$(_hash_struct)'\
496           $(_sc_header_without_use)
497
498 sc_prohibit_hash_pjw_without_use:
499         @h='"hash-pjw.h"' \
500         re='\<hash_pjw *\(' \
501           $(_sc_header_without_use)
502
503 sc_prohibit_safe_read_without_use:
504         @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
505           $(_sc_header_without_use)
506
507 sc_prohibit_argmatch_without_use:
508         @h='"argmatch.h"' \
509         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
510           $(_sc_header_without_use)
511
512 sc_prohibit_canonicalize_without_use:
513         @h='"canonicalize.h"' \
514         re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
515           $(_sc_header_without_use)
516
517 sc_prohibit_root_dev_ino_without_use:
518         @h='"root-dev-ino.h"' \
519         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
520           $(_sc_header_without_use)
521
522 sc_prohibit_openat_without_use:
523         @h='"openat.h"' \
524         re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
525           $(_sc_header_without_use)
526
527 # Prohibit the inclusion of c-ctype.h without an actual use.
528 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
529 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
530 sc_prohibit_c_ctype_without_use:
531         @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
532           $(_sc_header_without_use)
533
534 _empty =
535 _sp = $(_empty) $(_empty)
536 # The following list was generated by running:
537 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
538 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
539 _sig_functions = \
540   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
541   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
542   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
543   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
544 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
545 # The following were extracted from "man signal.h" manually.
546 _sig_types_and_consts =                                                 \
547   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
548   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
549   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
550   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
551   sigstack sigval stack_t ucontext_t
552 # generated via this:
553 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
554 _sig_names =                                                            \
555   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
556   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
557   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
558   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
559   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
560   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
561   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
562   SIGXCPU SIGXFSZ
563 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
564
565 # Prohibit the inclusion of signal.h without an actual use.
566 sc_prohibit_signal_without_use:
567         @h='<signal.h>'                                                 \
568         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
569           $(_sc_header_without_use)
570
571 # Prohibit the inclusion of strings.h without a sensible use.
572 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
573 sc_prohibit_strings_without_use:
574         @h='<strings.h>'                                                \
575         re='\<(strn?casecmp|ffs(ll)?)\>'                                \
576           $(_sc_header_without_use)
577
578 # Get the list of symbol names with this:
579 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
580 _intprops_names =                                                       \
581   TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT             \
582   TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM           \
583   INT_STRLEN_BOUND INT_BUFSIZE_BOUND
584 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
585 # Prohibit the inclusion of intprops.h without an actual use.
586 sc_prohibit_intprops_without_use:
587         @h='"intprops.h"'                                               \
588         re='\<($(_intprops_syms_re)) *\('                               \
589           $(_sc_header_without_use)
590
591 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
592 # Prohibit the inclusion of stddef.h without an actual use.
593 sc_prohibit_stddef_without_use:
594         @h='<stddef.h>'                                                 \
595         re='\<($(_stddef_syms_re)) *\('                                 \
596           $(_sc_header_without_use)
597
598 sc_obsolete_symbols:
599         @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
600         halt='do not use HAVE''_FCNTL_H or O'_NDELAY                    \
601           $(_sc_search_regexp)
602
603 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
604
605 # Each nonempty ChangeLog line must start with a year number, or a TAB.
606 sc_changelog:
607         @prohibit='^[^12        ]'                                      \
608         in_vc_files='^ChangeLog$$'                                      \
609         halt='found unexpected prefix in a ChangeLog'                   \
610           $(_sc_search_regexp)
611
612 # Ensure that each .c file containing a "main" function also
613 # calls set_program_name.
614 sc_program_name:
615         @require='set_program_name *\(m?argv\[0\]\);'                   \
616         in_vc_files='\.c$$'                                             \
617         containing='\<main *('                                          \
618         halt='the above files do not call set_program_name'             \
619           $(_sc_search_regexp)
620
621 # Ensure that each .c file containing a "main" function also
622 # calls bindtextdomain.
623 sc_bindtextdomain:
624         @require='bindtextdomain *\('                                   \
625         in_vc_files='\.c$$'                                             \
626         containing='\<main *('                                          \
627         halt='the above files do not call bindtextdomain'               \
628           $(_sc_search_regexp)
629
630 # Require that the final line of each test-lib.sh-using test be this one:
631 # Exit $fail
632 # Note: this test requires GNU grep's --label= option.
633 Exit_witness_file ?= tests/test-lib.sh
634 Exit_base := $(notdir $(Exit_witness_file))
635 sc_require_test_exit_idiom:
636         @if test -f $(srcdir)/$(Exit_witness_file); then                \
637           die=0;                                                        \
638           for i in $$(grep -l -F 'srcdir/$(Exit_base)'                  \
639                 $$($(VC_LIST) tests)); do                               \
640             tail -n1 $$i | grep '^Exit .' > /dev/null                   \
641               && : || { die=1; echo $$i; }                              \
642           done;                                                         \
643           test $$die = 1 &&                                             \
644             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
645               echo 1>&2 'Exit something';                               \
646               exit 1; } || :;                                           \
647         fi
648
649 sc_trailing_blank:
650         @prohibit='[     ]$$'                                           \
651         halt='found trailing blank(s)'                                  \
652           $(_sc_search_regexp)
653
654 # Match lines like the following, but where there is only one space
655 # between the options and the description:
656 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
657 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
658 sc_two_space_separator_in_usage:
659         @prohibit='^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
660         halt='help2man requires at least two spaces between an option and its description'\
661           $(_sc_search_regexp)
662
663 # Look for diagnostics that aren't marked for translation.
664 # This won't find any for which error's format string is on a separate line.
665 sc_unmarked_diagnostics:
666         @grep -nE                                                       \
667             '\<error *\([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT))      \
668           | grep -Ev '(_|ngettext ?)\(' &&                              \
669           { echo '$(ME): found unmarked diagnostic(s)' 1>&2;            \
670             exit 1; } || :
671
672 # Avoid useless parentheses like those in this example:
673 # #if defined (SYMBOL) || defined (SYM2)
674 sc_useless_cpp_parens:
675         @prohibit='^# *if .*defined *\('                                \
676         halt='found useless parentheses in cpp directive'               \
677           $(_sc_search_regexp)
678
679 # List headers for which HAVE_HEADER_H is always true, assuming you are
680 # using the appropriate gnulib module.  CAUTION: for each "unnecessary"
681 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
682 # requires the gnulib module that guarantees the usability of that header.
683 gl_assured_headers_ = \
684   cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
685
686 # Convert the list of names to upper case, and replace each space with "|".
687 az_ = abcdefghijklmnopqrstuvwxyz
688 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
689 gl_header_upper_case_or_ =                                              \
690   $$($(gl_assured_headers_)                                             \
691     | tr $(az_)/.- $(AZ_)___                                            \
692     | tr -s ' ' '|'                                                     \
693     )
694 sc_prohibit_always_true_header_tests:
695         @or=$(gl_header_upper_case_or_);                                \
696         re="HAVE_($$or)_H";                                             \
697         prohibit='\<'"$$re"'\>'                                         \
698         halt=$$(printf '%s\n'                                           \
699         'do not test the above HAVE_<header>_H symbol(s);'              \
700         '  with the corresponding gnulib module, they are always true') \
701           $(_sc_search_regexp)
702
703 # ==================================================================
704 gl_other_headers_ ?= \
705   intprops.h    \
706   openat.h      \
707   stat-macros.h
708
709 # Perl -lne code to extract "significant" cpp-defined symbols from a
710 # gnulib header file, eliminating a few common false-positives.
711 gl_extract_significant_defines_ = \
712   /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
713     && $$2 !~ /(?:rpl_|_used_without_)/\
714     && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
715     and print $$1
716
717 # Create a list of regular expressions matching the names
718 # of macros that are guaranteed to be defined by parts of gnulib.
719 define def_sym_regex
720         gen_h=$(gl_generated_headers_);                                 \
721         (cd $(gnulib_dir)/lib;                                          \
722           for f in *.in.h $(gl_other_headers_); do                      \
723             perl -lne '$(gl_extract_significant_defines_)' $$f;         \
724           done;                                                         \
725         ) | sort -u                                                     \
726           | grep -Ev '^ATTRIBUTE_NORETURN'                              \
727           | sed 's/^/^ *# *(define|undef)  */;s/$$/\\>/'
728 endef
729
730 # Don't define macros that we already get from gnulib header files.
731 sc_prohibit_always-defined_macros:
732         @if test -d $(gnulib_dir); then                                 \
733           case $$(echo all: | grep -l -f - Makefile) in Makefile);; *)  \
734             echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
735           esac;                                                         \
736           $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT))         \
737             && { echo '$(ME): define the above via some gnulib .h file' \
738                   1>&2;  exit 1; } || :;                                \
739         fi
740 # ==================================================================
741
742 # Prohibit checked in backup files.
743 sc_prohibit_backup_files:
744         @$(VC_LIST) | grep '~$$' &&                             \
745           { echo '$(ME): found version controlled backup file' 1>&2;    \
746             exit 1; } || :
747
748 # Require the latest GPL.
749 sc_GPL_version:
750         @prohibit='either ''version [^3]'                               \
751         halt='GPL vN, N!=3'                                             \
752           $(_sc_search_regexp)
753
754 # Require the latest GFDL.  Two regexp, since some .texi files end up
755 # line wrapping between 'Free Documentation License,' and 'Version'.
756 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
757 sc_GFDL_version:
758         @prohibit='$(_GFDL_regexp)'                                     \
759         halt='GFDL vN, N!=3'                                            \
760           $(_sc_search_regexp)
761
762 # Don't use Texinfo's @acronym{}.
763 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
764 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
765 sc_texinfo_acronym:
766         @prohibit='@acronym\{'                                          \
767         in_vc_files='$(texinfo_suffix_re_)'                             \
768         halt='found use of Texinfo @acronym{}'                          \
769           $(_sc_search_regexp)
770
771 cvs_keywords = \
772   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
773
774 sc_prohibit_cvs_keyword:
775         @prohibit='\$$($(cvs_keywords))\$$'                             \
776         halt='do not use CVS keyword expansion'                         \
777           $(_sc_search_regexp)
778
779 # This Perl code is slightly obfuscated.  Not only is each "$" doubled
780 # because it's in a Makefile, but the $$c's are comments;  we cannot
781 # use "#" due to the way the script ends up concatenated onto one line.
782 # It would be much more concise, and would produce better output (including
783 # counts) if written as:
784 #   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
785 # but that would be far less efficient, reading the entire contents
786 # of each file, rather than just the last two bytes of each.
787 # In addition, while the code below detects both blank lines and a missing
788 # newline at EOF, the above detects only the former.
789 #
790 # This is a perl script that is expected to be the single-quoted argument
791 # to a command-line "-le".  The remaining arguments are file names.
792 # Print the name of each file that ends in exactly one newline byte.
793 # I.e., warn if there are blank lines (2 or more newlines), or if the
794 # last byte is not a newline.  However, currently we don't complain
795 # about any file that contains exactly one byte.
796 # Exit nonzero if at least one such file is found, otherwise, exit 0.
797 # Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
798 #
799 # Use this if you want to remove trailing empty lines from selected files:
800 #   perl -pi -0777 -e 's/\n\n+$/\n/' files...
801 #
802 require_exactly_one_NL_at_EOF_ =                                        \
803   foreach my $$f (@ARGV)                                                \
804     {                                                                   \
805       open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;     \
806       my $$p = sysseek (F, -2, 2);                                      \
807       my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
808       my $$last_two_bytes;                                              \
809       defined $$p and $$p = sysread F, $$last_two_bytes, 2;             \
810       close F;                                                          \
811       $$c = "ignore read failure";                                      \
812       $$p && ($$last_two_bytes eq "\n\n"                                \
813               || substr ($$last_two_bytes,1) ne "\n")                   \
814           and (print $$f), $$fail=1;                                    \
815     }                                                                   \
816   END { exit defined $$fail }
817 sc_prohibit_empty_lines_at_EOF:
818         @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
819           || { echo '$(ME): empty line(s) or no newline at EOF'         \
820                 1>&2; exit 1; } || :
821
822 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
823 # This is a bit of a kludge, since it prevents use of the string
824 # even in comments, but for now it does the job with no false positives.
825 sc_prohibit_stat_st_blocks:
826         @prohibit='[.>]st_blocks'                                       \
827         halt='do not use st_blocks; use ST_NBLOCKS'                     \
828           $(_sc_search_regexp)
829
830 # Make sure we don't define any S_IS* macros in src/*.c files.
831 # They're already defined via gnulib's sys/stat.h replacement.
832 sc_prohibit_S_IS_definition:
833         @prohibit='^ *# *define  *S_IS'                                 \
834         halt='do not define S_IS* macros; include <sys/stat.h>'         \
835           $(_sc_search_regexp)
836
837 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
838 # that is shared by two definitions below.
839 perl_filename_lineno_text_ =                                            \
840     -e '  {'                                                            \
841     -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'                              \
842     -e '    ($$v = $$&) =~ s/\n/\\n/g;'                                 \
843     -e '    print "$$ARGV:$$n:$$v\n";'                                  \
844     -e '  }'
845
846 prohibit_doubled_word_RE_ ?= \
847   /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
848 prohibit_doubled_word_ =                                                \
849     -e 'while ($(prohibit_doubled_word_RE_))'                           \
850     $(perl_filename_lineno_text_)
851
852 # Define this to a regular expression that matches
853 # any filename:dd:match lines you want to ignore.
854 # The default is to ignore no matches.
855 ignore_doubled_word_match_RE_ ?= ^$$
856
857 sc_prohibit_doubled_word:
858         @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT))  \
859           | grep -vE '$(ignore_doubled_word_match_RE_)'                 \
860           | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
861
862 # A regular expression matching undesirable combinations of words like
863 # "can not"; this matches them even when the two words appear on different
864 # lines, but not when there is an intervening delimiter like "#" or "*".
865 prohibit_undesirable_word_seq_RE_ ?=                                    \
866   /\bcan\s+not\b/gims
867 prohibit_undesirable_word_seq_ =                                        \
868     -e 'while ($(prohibit_undesirable_word_seq_RE_))'                   \
869     $(perl_filename_lineno_text_)
870 # Define this to a regular expression that matches
871 # any filename:dd:match lines you want to ignore.
872 # The default is to ignore no matches.
873 ignore_undesirable_word_sequence_RE_ ?= ^$$
874
875 sc_prohibit_undesirable_word_seq:
876         @perl -n -0777 $(prohibit_undesirable_word_seq_)                \
877              $$($(VC_LIST_EXCEPT))                                      \
878           | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
879           && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
880
881 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
882 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
883 # Using test's -a and -o operators is not portable.
884 # We prefer test over [, since the latter is spelled [[ in configure.ac.
885 sc_prohibit_test_minus_ao:
886         @prohibit='(\<test| \[+) .+ -[ao] '                             \
887         halt='$(_ptm1); $(_ptm2)'                                       \
888           $(_sc_search_regexp)
889
890 # Avoid a test bashism.
891 sc_prohibit_test_double_equal:
892         @prohibit='(\<test| \[+) .+ == '                                \
893         containing='#! */bin/[a-z]*sh'                                  \
894         halt='use "test x = x", not "test x =''= x"'                    \
895           $(_sc_search_regexp)
896
897 # Each program that uses proper_name_utf8 must link with one of the
898 # ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
899 # The perl -0777 invocation below extracts the possibly-multi-line
900 # definition of LDADD from the appropriate Makefile.am and exits 0
901 # when it contains "ICONV".
902 sc_proper_name_utf8_requires_ICONV:
903         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
904         if test "x$$progs" != x; then                                   \
905           fail=0;                                                       \
906           for p in $$progs; do                                          \
907             dir=$$(dirname "$$p");                                      \
908             perl -0777                                                  \
909               -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'  \
910               $$dir/Makefile.am && continue;                            \
911             base=$$(basename "$$p" .c);                                 \
912             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
913               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
914           done;                                                         \
915           test $$fail = 1 &&                                            \
916             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
917               exit 1; } || :;                                           \
918         fi
919
920 # Warn about "c0nst struct Foo const foo[]",
921 # but not about "char const *const foo" or "#define const const".
922 sc_redundant_const:
923         @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'          \
924         halt='redundant "const" in declarations'                        \
925           $(_sc_search_regexp)
926
927 sc_const_long_option:
928         @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT))         \
929           | grep -Ev 'const struct option|struct option const' && {     \
930               echo 1>&2 '$(ME): add "const" to the above declarations'; \
931               exit 1; } || :
932
933 NEWS_hash =                                                             \
934   $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'              \
935        $(srcdir)/NEWS                                                   \
936      | perl -0777 -pe                                                   \
937         's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'       \
938      | md5sum -                                                         \
939      | sed 's/ .*//')
940
941 # Ensure that we don't accidentally insert an entry into an old NEWS block.
942 sc_immutable_NEWS:
943         @if test -f $(srcdir)/NEWS; then                                \
944           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
945             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
946         fi
947
948 # Update the hash stored above.  Do this after each release and
949 # for any corrections to old entries.
950 update-NEWS-hash: NEWS
951         perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
952           $(srcdir)/cfg.mk
953
954 # Ensure that we use only the standard $(VAR) notation,
955 # not @...@ in Makefile.am, now that we can rely on automake
956 # to emit a definition for each substituted variable.
957 # However, there is still one case in which @VAR@ use is not just
958 # legitimate, but actually required: when augmenting an automake-defined
959 # variable with a prefix.  For example, gettext uses this:
960 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
961 # otherwise, makeinfo would put German or French (current locale)
962 # navigation hints in the otherwise-English documentation.
963 #
964 # Allow the package to add exceptions via a hook in cfg.mk;
965 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
966 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
967 _makefile_at_at_check_exceptions ?=
968 sc_makefile_at_at_check:
969         @perl -ne '/\@[A-Z_0-9]+\@/'                                    \
970           -e ' && !/([A-Z_0-9]+)\s+=.*\@\1\@$$/'                        \
971           -e ''$(_makefile_at_at_check_exceptions)                      \
972           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
973             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
974           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
975
976 news-check: NEWS
977         if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS              \
978             | grep -E $(news-check-regexp) >/dev/null; then             \
979           :;                                                            \
980         else                                                            \
981           echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2;      \
982           exit 1;                                                       \
983         fi
984
985 sc_makefile_TAB_only_indentation:
986         @prohibit='^    [ ]{8}'                                         \
987         in_vc_files='akefile|\.mk$$'                                    \
988         halt='found TAB-8-space indentation'                            \
989           $(_sc_search_regexp)
990
991 sc_m4_quote_check:
992         @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
993         in_vc_files='(^configure\.ac|\.m4)$$'                           \
994         halt='quote the first arg to AC_DEF*'                           \
995           $(_sc_search_regexp)
996
997 fix_po_file_diag = \
998 'you have changed the set of files with translatable diagnostics;\n\
999 apply the above patch\n'
1000
1001 # Verify that all source files using _() are listed in po/POTFILES.in.
1002 po_file ?= $(srcdir)/po/POTFILES.in
1003 generated_files ?= $(srcdir)/lib/*.[ch]
1004 sc_po_check:
1005         @if test -f $(po_file); then                                    \
1006           grep -E -v '^(#|$$)' $(po_file)                               \
1007             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
1008           files=;                                                       \
1009           for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do      \
1010             test -r $$file || continue;                                 \
1011             case $$file in                                              \
1012               *.m4|*.mk) continue ;;                                    \
1013               *.?|*.??) ;;                                              \
1014               *) continue;;                                             \
1015             esac;                                                       \
1016             case $$file in                                              \
1017             *.[ch])                                                     \
1018               base=`expr " $$file" : ' \(.*\)\..'`;                     \
1019               { test -f $$base.l || test -f $$base.y; } && continue;;   \
1020             esac;                                                       \
1021             files="$$files $$file";                                     \
1022           done;                                                         \
1023           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
1024             | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2;      \
1025           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
1026             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
1027           rm -f $@-1 $@-2;                                              \
1028         fi
1029
1030 # Sometimes it is useful to change the PATH environment variable
1031 # in Makefiles.  When doing so, it's better not to use the Unix-centric
1032 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
1033 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
1034 sc_makefile_path_separator_check:
1035         @prohibit='PATH[=].*:'                                          \
1036         in_vc_files='akefile|\.mk$$'                                    \
1037         halt=$(msg)                                                     \
1038           $(_sc_search_regexp)
1039
1040 # Check that `make alpha' will not fail at the end of the process.
1041 writable-files:
1042         if test -d $(release_archive_dir); then :; else                 \
1043           for file in $(distdir).tar.gz                                 \
1044                       $(release_archive_dir)/$(distdir).tar.gz; do      \
1045             test -e $$file || continue;                                 \
1046             test -w $$file                                              \
1047               || { echo ERROR: $$file is not writable; fail=1; };       \
1048           done;                                                         \
1049           test "$$fail" && exit 1 || : ;                                \
1050         fi
1051
1052 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1053 sample-test = tests/sample-test
1054 texi = doc/$(PACKAGE).texi
1055 # Make sure that the copyright date in $(v_etc_file) is up to date.
1056 # Do the same for the $(sample-test) and the main doc/.texi file.
1057 sc_copyright_check:
1058         @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };'            \
1059         in_files=$(v_etc_file)                                          \
1060         halt='out of date copyright in $(v_etc_file); update it'        \
1061           $(_sc_search_regexp)
1062         @require='# Copyright \(C\) '$$(date +%Y)' Free'                \
1063         in_vc_files=$(sample-test)                                      \
1064         halt='out of date copyright in $(sample-test); update it'       \
1065           $(_sc_search_regexp)
1066         @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free'       \
1067         in_vc_files=$(texi)                                             \
1068         halt='out of date copyright in $(texi); update it'              \
1069           $(_sc_search_regexp)
1070
1071 # If tests/help-version exists and seems to be new enough, assume that its
1072 # use of init.sh and path_prepend_ is correct, and ensure that every other
1073 # use of init.sh is identical.
1074 # This is useful because help-version cross-checks prog --version
1075 # with $(VERSION), which verifies that its path_prepend_ invocation
1076 # sets PATH correctly.  This is an inexpensive way to ensure that
1077 # the other init.sh-using tests also get it right.
1078 _hv_file ?= $(srcdir)/tests/help-version
1079 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1080 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1081 sc_cross_check_PATH_usage_in_tests:
1082         @if test -f $(_hv_file); then                                   \
1083           grep -l 'VERSION mismatch' $(_hv_file) >/dev/null             \
1084             || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2;    \
1085                  exit 0; };                                             \
1086           grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null         \
1087             || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1088                  exit 1; };                                             \
1089           good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file));           \
1090           grep -LFx "$$good"                                            \
1091                 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT)))  \
1092               | grep . &&                                               \
1093             { echo "$(ME): the above files use path_prepend_ inconsistently" \
1094                 1>&2; exit 1; } || :;                                   \
1095         fi
1096
1097 # #if HAVE_... will evaluate to false for any non numeric string.
1098 # That would be flagged by using -Wundef, however gnulib currently
1099 # tests many undefined macros, and so we can't enable that option.
1100 # So at least preclude common boolean strings as macro values.
1101 sc_Wundef_boolean:
1102         @prohibit='^#define.*(yes|no|true|false)$$'                     \
1103         in_files='$(CONFIG_INCLUDE)'                                    \
1104         halt='Use 0 or 1 for macro values'                              \
1105           $(_sc_search_regexp)
1106
1107 sc_vulnerable_makefile_CVE-2009-4029:
1108         @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1109         in_files=$$(find $(srcdir) -name Makefile.in)                   \
1110         halt=$$(printf '%s\n'                                           \
1111           'the above files are vulnerable; beware of running'           \
1112           '  "make dist*" rules, and upgrade to fixed automake'         \
1113           '  see http://bugzilla.redhat.com/542609 for details')        \
1114           $(_sc_search_regexp)
1115
1116 vc-diff-check:
1117         (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1118         if test -s vc-diffs; then                               \
1119           cat vc-diffs;                                         \
1120           echo "Some files are locally modified:" 1>&2;         \
1121           exit 1;                                               \
1122         else                                                    \
1123           rm vc-diffs;                                          \
1124         fi
1125
1126 rel-files = $(DIST_ARCHIVES)
1127
1128 gnulib_dir ?= $(srcdir)/gnulib
1129 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1130 bootstrap-tools ?= autoconf,automake,gnulib
1131
1132 # If it's not already specified, derive the GPG key ID from
1133 # the signed tag we've just applied to mark this release.
1134 gpg_key_ID ?= \
1135   $$(git cat-file tag v$(VERSION) > .ann-sig \
1136      && gpgv .ann-sig - < /dev/null 2>&1 \
1137           | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1138
1139 translation_project_ ?= coordinator@translationproject.org
1140
1141 # Make info-gnu the default only for a stable release.
1142 ifeq ($(RELEASE_TYPE),stable)
1143   announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1144   announcement_mail_headers_ ?=                                         \
1145     To: info-gnu@gnu.org                                                \
1146     Cc: $(announcement_Cc_)                                             \
1147     Mail-Followup-To: $(PACKAGE_BUGREPORT)
1148 else
1149   announcement_Cc_ ?= $(translation_project_)
1150   announcement_mail_headers_ ?=                                         \
1151     To: $(PACKAGE_BUGREPORT)                                            \
1152     Cc: $(announcement_Cc_)
1153 endif
1154
1155 announcement: NEWS ChangeLog $(rel-files)
1156         @$(build_aux)/announce-gen                                      \
1157             --mail-headers='$(announcement_mail_headers_)'              \
1158             --release-type=$(RELEASE_TYPE)                              \
1159             --package=$(PACKAGE)                                        \
1160             --prev=$(PREV_VERSION)                                      \
1161             --curr=$(VERSION)                                           \
1162             --gpg-key-id=$(gpg_key_ID)                                  \
1163             --news=$(srcdir)/NEWS                                       \
1164             --bootstrap-tools=$(bootstrap-tools)                        \
1165             --gnulib-version=$(gnulib-version)                          \
1166             --no-print-checksums                                        \
1167             $(addprefix --url-dir=, $(url_dir_list))
1168
1169 ## ---------------- ##
1170 ## Updating files.  ##
1171 ## ---------------- ##
1172
1173 ftp-gnu = ftp://ftp.gnu.org/gnu
1174 www-gnu = http://www.gnu.org
1175
1176 upload_dest_dir_ ?= $(PACKAGE)
1177 emit_upload_commands:
1178         @echo =====================================
1179         @echo =====================================
1180         @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
1181         @echo "    --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1182         @echo "  $(rel-files)"
1183         @echo '# send the ~/announce-$(my_distdir) e-mail'
1184         @echo =====================================
1185         @echo =====================================
1186
1187 define emit-commit-log
1188   printf '%s\n' 'post-release administrivia' '' \
1189     '* NEWS: Add header line for next release.' \
1190     '* .prev-version: Record previous version.' \
1191     '* cfg.mk (old_NEWS_hash): Auto-update.'
1192 endef
1193
1194 .PHONY: no-submodule-changes
1195 no-submodule-changes:
1196         if test -d $(srcdir)/.git; then                                 \
1197           diff=$$(cd $(srcdir) && git submodule -q foreach              \
1198                   git diff-index --name-only HEAD)                      \
1199             || exit 1;                                                  \
1200           case $$diff in '') ;;                                         \
1201             *) echo '$(ME): submodule files are locally modified:';     \
1202                 echo "$$diff"; exit 1;; esac;                           \
1203         else                                                            \
1204           : ;                                                           \
1205         fi
1206
1207 submodule-checks ?= no-submodule-changes public-submodule-commit
1208
1209 # Ensure that each sub-module commit we're using is public.
1210 # Without this, it is too easy to tag and release code that
1211 # cannot be built from a fresh clone.
1212 .PHONY: public-submodule-commit
1213 public-submodule-commit:
1214         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1215           cd $(srcdir) &&                                               \
1216           git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1217               = '$$(git merge-base origin $$sha1)'                      \
1218             || { echo '$(ME): found non-public submodule commit' >&2;   \
1219                  exit 1; };                                             \
1220         else                                                            \
1221           : ;                                                           \
1222         fi
1223 # This rule has a high enough utility/cost ratio that it should be a
1224 # dependent of "check" by default.  However, some of us do occasionally
1225 # commit a temporary change that deliberately points to a non-public
1226 # submodule commit, and want to be able to use rules like "make check".
1227 # In that case, run e.g., "make check gl_public_submodule_commit="
1228 # to disable this test.
1229 gl_public_submodule_commit ?= public-submodule-commit
1230 check: $(gl_public_submodule_commit)
1231
1232 .PHONY: alpha beta stable
1233 ALL_RECURSIVE_TARGETS += alpha beta stable
1234 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1235         test $@ = stable                                                \
1236           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$'         \
1237                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1238           || :
1239         $(MAKE) vc-diff-check
1240         $(MAKE) news-check
1241         $(MAKE) distcheck
1242         $(MAKE) dist XZ_OPT=-9ev
1243         $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1244         $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1245
1246 # Override this in cfg.mk if you follow different procedures.
1247 release-prep-hook ?= release-prep
1248
1249 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1250 .PHONY: release-prep
1251 release-prep:
1252         case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1253           *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1254         $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
1255         if test -d $(release_archive_dir); then                 \
1256           ln $(rel-files) $(release_archive_dir);               \
1257           chmod a-w $(rel-files);                               \
1258         fi
1259         echo $(VERSION) > $(prev_version_file)
1260         $(MAKE) update-NEWS-hash
1261         perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
1262         $(emit-commit-log) > .ci-msg
1263         $(VC) commit -F .ci-msg -a
1264         rm .ci-msg
1265
1266 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1267 # if the default $(PACKAGE)-derived name doesn't apply.
1268 gendocs_options_ ?=
1269
1270 .PHONY: web-manual
1271 web-manual:
1272         @test -z "$(manual_title)" \
1273           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1274         @cd '$(srcdir)/doc'; \
1275           $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1276              -o '$(abs_builddir)/doc/manual' \
1277              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1278             "$(PACKAGE_NAME) - $(manual_title)"
1279         @echo " *** Upload the doc/manual directory to web-cvs."
1280
1281 # Code Coverage
1282
1283 init-coverage:
1284         $(MAKE) $(AM_MAKEFLAGS) clean
1285         lcov --directory . --zerocounters
1286
1287 COVERAGE_CCOPTS ?= "-g --coverage"
1288 COVERAGE_OUT ?= doc/coverage
1289
1290 build-coverage:
1291         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1292         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1293         mkdir -p $(COVERAGE_OUT)
1294         lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1295                 --capture
1296
1297 gen-coverage:
1298         genhtml --output-directory $(COVERAGE_OUT) \
1299                 $(COVERAGE_OUT)/$(PACKAGE).info \
1300                 --highlight --frames --legend \
1301                 --title "$(PACKAGE_NAME)"
1302
1303 coverage: init-coverage build-coverage gen-coverage
1304
1305 # Update gettext files.
1306 PACKAGE ?= $(shell basename $(PWD))
1307 PO_DOMAIN ?= $(PACKAGE)
1308 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1309 PODIR ?= po
1310 refresh-po:
1311         rm -f $(PODIR)/*.po && \
1312         echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1313         wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1314         echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1315         echo 'en@quot' >> $(PODIR)/LINGUAS && \
1316         ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1317
1318  # Running indent once is not idempotent, but running it twice is.
1319 INDENT_SOURCES ?= $(C_SOURCES)
1320 .PHONY: indent
1321 indent:
1322         indent $(INDENT_SOURCES)
1323         indent $(INDENT_SOURCES)
1324
1325 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1326 # put the assignments in this variable.
1327 update-copyright-env ?=
1328
1329 # Run this rule once per year (usually early in January)
1330 # to update all FSF copyright year lists in your project.
1331 # If you have an additional project-specific rule,
1332 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1333 # By default, exclude all variants of COPYING; you can also
1334 # add exemptions (such as ChangeLog..* for rotated change logs)
1335 # in the file .x-update-copyright.
1336 .PHONY: update-copyright
1337 update-copyright:
1338         grep -l -w Copyright                                             \
1339           $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1340           | $(update-copyright-env) xargs $(build_aux)/$@
1341
1342 # NOTE: This test is silently skipped if $(_gl_TS_dir)/Makefile.am
1343 # does not mention noinst_HEADERS.
1344 # NOTE: to override these _gl_TS_* default values, you must
1345 # define the variable(s) using "export" in cfg.mk.
1346 _gl_TS_dir ?= src
1347 ALL_RECURSIVE_TARGETS += sc_tight_scope
1348 sc_tight_scope: tight-scope.mk
1349         @grep noinst_HEADERS $(_gl_TS_dir)/Makefile.am > /dev/null 2>&1 \
1350           && $(MAKE) -s -C $(_gl_TS_dir) -f Makefile                    \
1351               -f '$(abs_srcdir)/tight-scope.mk' _gl_tight_scope         \
1352           || :
1353         @rm -f $<
1354
1355 tight-scope.mk: $(ME)
1356         @rm -f $@ $@-t
1357         @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(ME) > $@-t
1358         @chmod a=r $@-t && mv $@-t $@
1359
1360 ifeq (a,b)
1361 # TS-start
1362 # Most functions should have static scope.
1363 # Any that don't must be marked with `extern', but `main'
1364 # and `usage' are exceptions: they're always extern, but
1365 # do not need to be marked.
1366 _gl_TS_unmarked_extern_functions ?= main usage
1367 _gl_TS_function_match ?= \
1368   /^(?:extern|XTERN) +(?:void|(?:struct |const |enum )?\S+) +\**(\S+) +\(/
1369
1370 # The second nm|grep checks for file-scope variables with `extern' scope.
1371 # Without gnulib's progname module, you might put program_name here.
1372 _gl_TS_unmarked_extern_vars ?=
1373
1374 # NOTE: the _match variables are perl expressions -- not mere regular
1375 # expressions -- so that you can extend them to match other patterns
1376 # and easily extract matched variable names.
1377 # For example, if your project declares some global variables via
1378 # a macro like this: GLOBAL(type, var_name, initializer), then you
1379 # can override this definition to automatically extract those names:
1380 # export _gl_TS_var_match = \
1381 #   /^(?:extern|XTERN) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1382 _gl_TS_var_match ?= /^(?:extern|XTERN) .*?\**(\w+)(\[.*?\])?;/
1383 .PHONY: _gl_tight_scope
1384 _gl_tight_scope: $(bin_PROGRAMS)
1385         t=exceptions-$$$$;                                              \
1386         trap 's=$$?; rm -f $$t; exit $$s' 0;                            \
1387         for sig in 1 2 3 13 15; do                                      \
1388           eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1389         done;                                                           \
1390         src=`for f in $(SOURCES); do                                    \
1391                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1392         hdr=`for f in $(noinst_HEADERS); do                             \
1393                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1394         ( printf '^%s$$\n' $(_gl_TS_unmarked_extern_functions);         \
1395           grep -h -A1 '^extern .*[^;]$$' $$src                          \
1396             | grep -vE '^(extern |--)' | sed 's/ .*//';                 \
1397           perl -lne '$(_gl_TS_function_match)'                          \
1398                  -e 'and print $$1' $$hdr;                              \
1399         ) | sort -u | sed 's/^/^/;s/$$/$$/' > $$t;                      \
1400         nm -e *.$(OBJEXT) | sed -n 's/.* T //p' | grep -Ev -f $$t       \
1401           && { echo the above functions should have static scope >&2;   \
1402                exit 1; } || : ;                                         \
1403         ( printf '^%s$$\n' $(_gl_TS_unmarked_extern_vars);              \
1404           perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"'           \
1405             $$hdr *.h ) | sort -u > $$t;                                \
1406         nm -e *.$(OBJEXT) | sed -n 's/.* [BCDGRS] //p'                  \
1407             | sort -u | grep -Ev -f $$t                                 \
1408           && { echo the above variables should have static scope >&2;   \
1409                exit 1; } || :
1410 # TS-end
1411 endif